Description

Hi, when trying to calculate $area in python script, that character makes the script fail. 

current workaround is to define a text variable and to modify runalg line to call the variable instead of $area text. 

I didn't find any escape character to make that work

History

#1 - 2014-03-27 07:43 AM - Alexander Bruy

- Status changed from Open to Feedback

Python field calculator used different syntax. See http://gis-lab.info/qa/fieldpyculator.html and 

http://anitagraser.com/2013/04/20/advanced-python-field-calculator/. If you want use same syntax, as QGIS Field Calculator, use Field calculator algorithm

#2 - 2014-03-27 08:04 AM - Regis Haubourg

In fact, I'm not using advanced python field calculator but simple field calculator

#3 - 2014-03-27 08:11 AM - Alexander Bruy

Can't reproduce. I tested with two layers one in WGS84, another in projected CRS, in both cases $area expression works fine and new field with values

created

#4 - 2014-03-27 08:31 AM - Regis Haubourg

following script :

##calcul_surface=name

##vectorlayer_tablea=vector

##output_layer_alg0=output vector

outputs_0=Processing.runalg("qgis:fieldcalculator", vectorlayer_tablea, A_obj_sfce, 0, 20, 5, True, $area, output_layer_alg0)

raises following error:

2025-06-13 1/2

http://gis-lab.info/qa/fieldpyculator.html
http://anitagraser.com/2013/04/20/advanced-python-field-calculator/


Algorithm calcul_surface starting...

invalid syntax (, line 5) See log for more details

#5 - 2014-03-27 08:59 AM - Alexander Bruy

You use wrong syntax for runalg call. Try to execute Field calculator from toolbox and look at algorithm commandline in Processing log.

Formula should be quoted, in your case

##calcul_surface=name

##vectorlayer_tablea=vector

##output_layer_alg0=output vector

outputs_0=Processing.runalg("qgis:fieldcalculator", vectorlayer_tablea, A_obj_sfce, 0, 20, 5, True, "$area", output_layer_alg0)

#6 - 2014-03-27 09:19 AM - Regis Haubourg

Well, 

I exported a model to a script, I did not type it by hand.  I suppose that export process just forget double quotes around the formula. Thanks for your help.

Anyone ready to debug the export process?

#7 - 2014-06-23 06:38 AM - Regis Haubourg

- Status changed from Feedback to Closed

Closing it since it is a very uncommon issue

#8 - 2015-06-07 04:31 AM - Giovanni Manghi

- Category changed from 94 to Processing/Core
